///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit PZed;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Registry, Menus, ExtCtrls, ComCtrls, ToolWin,
  Initer, Buttons, OptiF, MySys, KOLFileInString, KOLTextFileInString,
  KOLAnIniFile, KOLForPaths, KOL;

type
  TMainForm = class(TForm)
    Mai_nMenu: TMainMenu;
    FileMenu: TMenuItem;
    HelpMenu: TMenuItem;
    ExitMenu: TMenuItem;
    MainBar: TCoolBar;
    MainStatusBar: TStatusBar;
    ReadMeMenu: TMenuItem;
    AboutMenu: TMenuItem;
    RunPZSB: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    PzStartMenu: TMenuItem;
    ResursMenu: TMenuItem;
    N1: TMenuItem;
    TextsOptMenu: TMenuItem;
    ResSB: TSpeedButton;
    BasaMenu: TMenuItem;
    BasOptMenu: TMenuItem;
    IshMenu: TMenuItem;
    IshSB: TSpeedButton;
    N2: TMenuItem;
    N3: TMenuItem;
    LmpPrintsMenu: TMenuItem;
    Bas_Mult_Prints_Razd1Menu: TMenuItem;
    Bas_Mult_Prints_Razd2Menu: TMenuItem;
    Bas_Mult_Prints_Razd3Menu: TMenuItem;
    SpeedButton2: TSpeedButton;
    LmpItemsMenu: TMenuItem;
    LmpLeversMenu: TMenuItem;
    LmpPerksMenu: TMenuItem;
    LmpSpellsMenu: TMenuItem;
    LmpUnitsMenu: TMenuItem;
    LmpItemsMenu1: TMenuItem;
    LmpItemsMenu2: TMenuItem;
    LmpItemsMenu3: TMenuItem;
    LmpItemsMenu4: TMenuItem;
    LmpItemsMenu5: TMenuItem;
    LmpItemsMenu6: TMenuItem;
    LmpPerksMenu1: TMenuItem;
    LmpPerksMenu2: TMenuItem;
    LmpSpellsMenu1: TMenuItem;
    LmpSpellsMenu2: TMenuItem;
    LmpSpellsMenu3: TMenuItem;
    LmpSpellsMenu4: TMenuItem;
    LmpSpellsMenu5: TMenuItem;
    LmpUnitsMenu1: TMenuItem;
    LmpUnitsMenu2: TMenuItem;
    LmpUnitsMenu3: TMenuItem;
    LmpUnitsMenu4: TMenuItem;
    AcksMenu: TMenuItem;
    ItemsMenu: TMenuItem;
    LeversMenu: TMenuItem;
    PerksMenu: TMenuItem;
    PrintsMenu: TMenuItem;
    QuestsMenu: TMenuItem;
    SpellsMenu: TMenuItem;
    UnitsMenu: TMenuItem;
    AcksMenu1: TMenuItem;
    AcksMenu2: TMenuItem;
    AcksMenu3: TMenuItem;
    ItemsMenu1: TMenuItem;
    ItemsMenu2: TMenuItem;
    ItemsMenu3: TMenuItem;
    ItemsMenu4: TMenuItem;
    ItemsMenu5: TMenuItem;
    ItemsMenu6: TMenuItem;
    PerksMenu1: TMenuItem;
    PerksMenu2: TMenuItem;
    PrintsMenu1: TMenuItem;
    PrintsMenu2: TMenuItem;
    PrintsMenu3: TMenuItem;
    QuestsMenu1: TMenuItem;
    QuestsMenu2: TMenuItem;
    SpellsMenu1: TMenuItem;
    SpellsMenu2: TMenuItem;
    SpellsMenu3: TMenuItem;
    SpellsMenu4: TMenuItem;
    SpellsMenu5: TMenuItem;
    UnitsMenu1: TMenuItem;
    UnitsMenu2: TMenuItem;
    UnitsMenu3: TMenuItem;
    UnitsMenu4: TMenuItem;
    ResOptMenu: TMenuItem;
    TextEditMenu: TMenuItem;
    TextEdSB: TSpeedButton;
    WindowsMenu: TMenuItem;
    CascadeWindMenu: TMenuItem;
    TileWindMenu: TMenuItem;
    ArrangeIconsWindMenu: TMenuItem;
    procedure ExitButClick(Sender: TObject);
    procedure ExitMenuClick(Sender: TObject);
    procedure ShowHint(Sender : TObject);
    procedure FormActivate(Sender: TObject);
    procedure ReadMeMenuClick(Sender: TObject);
    procedure AboutMenuClick(Sender: TObject);
    procedure RunPZSBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PzStartMenuClick(Sender: TObject);
    procedure ResursMenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TextsOptMenuClick(Sender: TObject);
    procedure ResSBClick(Sender: TObject);
    procedure BasOptMenuClick(Sender: TObject);
    procedure IshMenuClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure IshSBClick(Sender: TObject);
    procedure Bas_Mult_Prints_Razd1MenuClick(Sender: TObject);
    procedure Bas_Mult_Prints_Razd2MenuClick(Sender: TObject);
    procedure Bas_Mult_Prints_Razd3MenuClick(Sender: TObject);
    procedure LmpLeversMenuClick(Sender: TObject);
    procedure LeversMenuClick(Sender: TObject);
    procedure PrintsMenu1Click(Sender: TObject);
    procedure PrintsMenu2Click(Sender: TObject);
    procedure PrintsMenu3Click(Sender: TObject);
    procedure ItemsMenu1Click(Sender: TObject);
    procedure LmpItemsMenu1Click(Sender: TObject);
    procedure ItemsMenu2Click(Sender: TObject);
    procedure LmpItemsMenu2Click(Sender: TObject);
    procedure ItemsMenu3Click(Sender: TObject);
    procedure LmpItemsMenu3Click(Sender: TObject);
    procedure ItemsMenu4Click(Sender: TObject);
    procedure LmpItemsMenu4Click(Sender: TObject);
    procedure ItemsMenu5Click(Sender: TObject);
    procedure LmpItemsMenu5Click(Sender: TObject);
    procedure ItemsMenu6Click(Sender: TObject);
    procedure LmpItemsMenu6Click(Sender: TObject);
    procedure PerksMenu1Click(Sender: TObject);
    procedure LmpPerksMenu1Click(Sender: TObject);
    procedure PerksMenu2Click(Sender: TObject);
    procedure LmpPerksMenu2Click(Sender: TObject);
    procedure QuestsMenu1Click(Sender: TObject);
    procedure QuestsMenu2Click(Sender: TObject);
    procedure LmpUnitsMenu1Click(Sender: TObject);
    procedure UnitsMenu1Click(Sender: TObject);
    procedure UnitsMenu2Click(Sender: TObject);
    procedure LmpUnitsMenu2Click(Sender: TObject);
    procedure UnitsMenu3Click(Sender: TObject);
    procedure LmpUnitsMenu3Click(Sender: TObject);
    procedure UnitsMenu4Click(Sender: TObject);
    procedure LmpUnitsMenu4Click(Sender: TObject);
    procedure SpellsMenu1Click(Sender: TObject);
    procedure LmpSpellsMenu1Click(Sender: TObject);
    procedure SpellsMenu2Click(Sender: TObject);
    procedure LmpSpellsMenu2Click(Sender: TObject);
    procedure SpellsMenu3Click(Sender: TObject);
    procedure LmpSpellsMenu3Click(Sender: TObject);
    procedure SpellsMenu4Click(Sender: TObject);
    procedure LmpSpellsMenu4Click(Sender: TObject);
    procedure SpellsMenu5Click(Sender: TObject);
    procedure LmpSpellsMenu5Click(Sender: TObject);
    procedure AcksMenu1Click(Sender: TObject);
    procedure AcksMenu2Click(Sender: TObject);
    procedure AcksMenu3Click(Sender: TObject);
    procedure ResOptMenuClick(Sender: TObject);
    procedure TextEditMenuClick(Sender: TObject);
    procedure TextEdSBClick(Sender: TObject);
    procedure CascadeWindMenuClick(Sender: TObject);
    procedure TileWindMenuClick(Sender: TObject);
    procedure ArrangeIconsWindMenuClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  Procedure SetMenu;
  Procedure CloseLishnee;
  Procedure CloseLishneeBase;
var
  MainForm: TMainForm;

implementation

uses  AboutF, ResursF, TextsOptForm, BaseOptForm,
  IshForm, ShabRedDbForm, PrintsDbR1Form, PrintsDbR2Form, PrintsDbR3Form,
  LmpLeversForm, LeversForm, UncAskForm, SinglPrintsDbR1Form,
  SinglPrintsDbR2Form, SinglPrintsDbR3Form, SinglItemsIdbR1Form,
  ItemsIdbR1Form, SinglItemsIdbR2Form, ItemsIdbR2Form, SinglItemsIdbR3Form,
  ItemsIdbR3Form, SinglItemsIdbR4Form, ItemsIdbR4Form, SinglItemsIdbR5Form,
  ItemsIdbR5Form, SinglItemsIdbR6Form, ItemsIdbR6Form, SinglPerksPdbR1Form,
  PerksPdbR1Form, SinglPerksPdbR2Form, PerksPdbR2Form, SinglQuestsQdbR1Form,
  SinglQuestsQdbR2Form, UnitsUdbR1Form, SinglUnitsUdbR1Form, SinglUnitsUdbR2Form,
  ValueSelectorForm, UnitsUdbR2Form, SinglUnitsUdbR3Form, UnitsUdbR3Form,
  SinglUnitsUdbR4Form, UnitsUdbR4Form, SinglSpellsSdbR1Form,
  SpellsSdbR1Form, SinglSpellsSdbR2Form, SpellsSdbR2Form,
  SinglSpellsSdbR3Form, SpellsSdbR3Form, SinglSpellsSdbR4Form,
  SpellsSdbR4Form, SinglSpellsSdbR5Form, SpellsSdbR5Form, SinglAcksDbR1Form,
  SinglAcksDbR2Form, SinglAcksDbR3Form, ResPathsForm, TextEdForm;

{$R *.DFM}



Procedure SetMenu;
begin
  // ,         ,
  //   ...
  //
  //        .
  //   -       .
end;

Procedure CloseLishnee;
begin
  If ResursFormClosed = false then ResursForm.Close;
end;

Procedure CloseLishneeBase;
begin
  If PrintsDbR1FClosed = false then PrintsDbR1F.Close;
  If PrintsDbR2FClosed = false then PrintsDbR2F.Close;
  If PrintsDbR3FClosed = false then PrintsDbR3F.Close;
  If LmpLeversFClosed = false then LmpLeversF.Close;
  If LeversFClosed = false then LeversF.Close;
  If SinglPrintsDbR1FClosed = false then SinglPrintsDbR1F.Close;
  If SinglPrintsDbR2FClosed = false then SinglPrintsDbR2F.Close;
  If SinglPrintsDbR3FClosed = false then SinglPrintsDbR3F.Close;
  If SinglItemsIdbR1FClosed = false then SinglItemsIdbR1F.Close;
  If ItemsIdbR1FClosed = false then ItemsIdbR1F.Close;
  If SinglItemsIdbR2FClosed = false then SinglItemsIdbR2F.Close;
  If ItemsIdbR2FClosed = false then ItemsIdbR2F.Close;
  If SinglItemsIdbR3FClosed = false then SinglItemsIdbR3F.Close;
  If ItemsIdbR3FClosed = false then ItemsIdbR3F.Close;
  If SinglItemsIdbR4FClosed = false then SinglItemsIdbR4F.Close;
  If ItemsIdbR4FClosed = false then ItemsIdbR4F.Close;
  If SinglItemsIdbR5FClosed = false then SinglItemsIdbR5F.Close;
  If ItemsIdbR5FClosed = false then ItemsIdbR5F.Close;
  If SinglItemsIdbR6FClosed = false then SinglItemsIdbR6F.Close;
  If ItemsIdbR6FClosed = false then ItemsIdbR6F.Close;
  If SinglPerksPdbR1FClosed = false then SinglPerksPdbR1F.Close;
  If PerksPdbR1FClosed = false then PerksPdbR1F.Close;
  If SinglPerksPdbR2FClosed = false then SinglPerksPdbR2F.Close;
  If PerksPdbR2FClosed = false then PerksPdbR2F.Close;
  If SinglQuestsQdbR1FClosed = false then SinglQuestsQdbR1F.Close;
  If SinglQuestsQdbR2FClosed = false then SinglQuestsQdbR2F.Close;
  If UnitsUdbR1FClosed = false then UnitsUdbR1F.Close;
  If SinglUnitsUdbR1FClosed = false then SinglUnitsUdbR1F.Close;
  If SinglUnitsUdbR2FClosed = false then SinglUnitsUdbR2F.Close;
  If UnitsUdbR2FClosed = false then UnitsUdbR2F.Close;
  If SinglUnitsUdbR3FClosed = false then SinglUnitsUdbR3F.Close;
  If UnitsUdbR3FClosed = false then UnitsUdbR3F.Close;
  If SinglUnitsUdbR4FClosed = false then SinglUnitsUdbR4F.Close;
  If UnitsUdbR4FClosed = false then UnitsUdbR4F.Close;
  If SinglSpellsSdbR1FClosed = false then SinglSpellsSdbR1F.Close;
  If SpellsSdbR1FClosed = false then SpellsSdbR1F.Close;
  If SinglSpellsSdbR2FClosed = false then SinglSpellsSdbR2F.Close;
  If SpellsSdbR2FClosed = false then SpellsSdbR2F.Close;
  If SinglSpellsSdbR3FClosed = false then SinglSpellsSdbR3F.Close;
  If SpellsSdbR3FClosed = false then SpellsSdbR3F.Close;
  If SinglSpellsSdbR4FClosed = false then SinglSpellsSdbR4F.Close;
  If SpellsSdbR4FClosed = false then SpellsSdbR4F.Close;
  If SinglSpellsSdbR5FClosed = false then SinglSpellsSdbR5F.Close;
  If SpellsSdbR5FClosed = false then SpellsSdbR5F.Close;
  If SinglAcksDbR1FClosed = false then SinglAcksDbR1F.Close;
  If SinglAcksDbR2FClosed = false then SinglAcksDbR2F.Close;
  If SinglAcksDbR3FClosed = false then SinglAcksDbR3F.Close;
end;

procedure TMainForm.ShowHint(Sender : TObject);
begin
  {}
  MainForm.MainStatusBar.Panels[0].text := Application.hint;
end;

procedure TMainForm.ExitButClick(Sender: TObject);
begin
  MainForm.close;
end;



procedure TMainForm.ExitMenuClick(Sender: TObject);
begin
  MainForm.Close;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  Application.OnHint := MainForm.ShowHint;
end;

procedure TMainForm.ReadMeMenuClick(Sender: TObject);
begin
  WinExec(Pchar('notepad.exe '+Path+'readme.txt'), Sw_ShowNormal);
end;

procedure TMainForm.AboutMenuClick(Sender: TObject);
begin
  AboutForm := TAboutForm.Create(Application);
  AboutForm.showmodal;
  AboutForm.Free;
end;

procedure TMainForm.RunPZSBClick(Sender: TObject);
begin
  WinExec(PChar(PzPath+'starter.exe'),sw_shownormal);
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  Caption := Zagolov;
  Height := MfHeight;
  Width := MfWidth;
  Top := MfTop;
  Left := MfLeft;
  WindowState := Forms.WsNormal;
  Refresh;
  WindowState := IntToWstate(MfWstate);
  Refresh;
end;

procedure TMainForm.PzStartMenuClick(Sender: TObject);
var
longg : longbool;
Card : cardinal;
i111 : _startupinfoa;
begin
  WinExec(PChar(PzPath+'starter.exe'),sw_shownormal);
end;

procedure TMainForm.ResursMenuClick(Sender: TObject);
begin
  if ResursMenu.Checked = false then begin
    ResursForm := TResursForm.Create(Application);
    ResursForm.show;
    ResursMenu.Checked := true;
  end
  else begin
    ResursForm.Close;
    ResursMenu.Checked := false;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := CaFree;

  //   ...
  // ...
  MfHeight := Height;
  MfWidth := Width;
  MfTop := top;
  MfLeft := left;
  MfWstate := WstateToInt(WindowState);

  //  
  AnIniFil.Load(IniFilPath);
  AnIniFil.WriteInteger('MainSettings','MfHeight',MfHeight);
  AnIniFil.WriteInteger('MainSettings','MfWidth',MfWidth);
  AnIniFil.WriteInteger('MainSettings','MfTop',MfTop);
  AnIniFil.WriteInteger('MainSettings','MfLeft',MfLeft);
  AnIniFil.WriteInteger('MainSettings','MfWstate',MfWstate);
  AnIniFil.Save(IniFilPath);
end;

procedure TMainForm.TextsOptMenuClick(Sender: TObject);
begin
  TextsOptF.ShowModal;
end;

procedure TMainForm.ResSBClick(Sender: TObject);
begin
  if ResursMenu.Checked = false then begin
    ResursForm := TResursForm.Create(Application);
    ResursForm.show;
    ResursMenu.Checked := true;
  end
  else begin
    ResursForm.Close;
    ResursMenu.Checked := false;
  end;
end;

procedure TMainForm.BasOptMenuClick(Sender: TObject);
begin
  BaseOptF.ShowModal;
end;

procedure TMainForm.IshMenuClick(Sender: TObject);
begin
  IshF.IshMenalsa := false;
  IshF.ShowModal;
  If IshF.IshMenalsa = true then CloseLishneeBase; //  
                                          //  .
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
var

   S, T: string;
   Fil1 : TFileInString;
   I1 : integer;
   TextFil1 : TTextFileInString;
   TempDbl : Double;
   TestBool, TestBool2 : boolean;

begin
  //     .

  //ShowMessage('           .     -       ,      .     ,       .'+'       .');

  {Str(1.4:2:1, T);
  S := T + ' rounds to ' + IntToStr(Round(1.4)) + #13#10;
  Str(1.5:2:1, T);
  S := S + T + ' rounds to ' + IntToStr(Round(1.5)) + #13#10;
  Str(-1.4:2:1, T);
  S := S + T + ' rounds to ' + IntToStr(Round(-1.4)) + #13#10;
  Str(-1.5:2:1, T);
  S := S + T + ' rounds to ' + IntToStr(Round(-1.5));
  MessageDlg(S, mtInformation, [mbOk], 0);
  MessageDLG('      CD.       ?',MtConfirmation,[mbYes]+[mbNo],0);
  MessageDLG('   ?',MtConfirmation,[mbYes]+[mbNo],0);}
  //S := '12345';
  //MessageDLG(IntToStr(GetStringSize('')),mtConfirmation,[mbYes]+[mbNo],0);
  //UncAskF.ShowModal;
  (*Fil1 := TFileInString.Init;
  Fil1.MakNewFile;
  S := '';
  S := AddPodPole(S,'123',0);
  S := AddPodPole(S,'321',1);
  S := AddPodPole(S,'456',2);
  S := AddPodPole(S,'654',3);
  S := AddPodPole(S,'MMX -  !!!',4);
  Fil1.FileString := S;
  Fil1.Siz := Length(S);
  Fil1.Save('C:\ishak.hx');
  Fil1.Free;*)

  (*I1 := ShopInfoToUnsLong('0,1,2,3 fgddg');
  ShowMessage(IntToStr(I1));
  S := UnsLongToShopInfo(I1);
  ShowMessage(S);*)

  //ShowMessage(BoolToStr(CheckList(ListBezProbelov(', , , , , .'))));

  //ShowMessage(BoolToStr(CheckShopInfo('1,2,3,4,5')));

  {Fil1 := TFileInString.Init;
  Fil1.MakNewFile;
  Fil1.FileString := StrToList(ListBezProbelov('gz3g, gz5g'));
  Fil1.Siz := Length(Fil1.FileString);
  Fil1.Save('C:\ishak.hx');
  Fil1.Free;}

  //ShowMessage(IntToStr(Length(StrToPzDbStr2('123'))));

  //ShowMessage(SelectValue(''+#13+''+#13));

  {Fil1 := TFileInString.Init;
  Fil1.Load(Path+'\TestFls\0000011.fld');
  S := EditASound(Fil1.FileString);
  If S <> 'NIL' then begin
    Fil1.FileString := S;
    Fil1.Save(Path+'\TestFls\0000011.fld');
  end;
  Fil1.Free;}

  {TextFil1 := TTextFileInString.Init;
  TextFil1.Load(Path+'\shablons\ASounds\first.zap');
  TextFil1.Cursor := 1;
  S := TextFil1.CurRead(45);
  ShowMessage(S+'    |    '+IntToStr(TextFil1.Cursor));
  repeat
    S := TextFil1.CurReadLn;
    ShowMessage(S+'    |    '+IntToStr(TextFil1.Cursor));
  until TextFil1.Eof = true;
  TextFil1.Free;}

  {TextFil1 := TTextFileInString.Init;
  TextFil1.Load(Path+'\TestFls\test.txt');
  TextFil1.Cursor := 1;
  TextFil1.CurReadLn;
  TextFil1.CurReadLn;
  TextFil1.CurReadLn;
  TextFil1.CurReadLn;
  TextFil1.CurReadLn;
  TextFil1.CurReadLn;
  TextFil1.CurReadLn;
  TextFil1.CurReadLn;
  //TextFil1.CurReadLn;
  TextFil1.ReplaceString(TextFil1.Cursor,'');
  TextFil1.Save(Path+'\TestFls\test.txt');
  TextFil1.Free;}

  {AnIniFil := TAnIniFile.Init;
  AnIniFil.Load(Path+'TestFls\settings.ini');
  S := AnIniFil.ReadString('Settings','DefalDir');
  ShowMessage(S);
  TempDbl := AnIniFil.ReadFloat('Settings','ver');
  ShowMessage(FloatToStr(TempDbl));
  TempDbl := AnIniFil.ReadInteger('Settings','NumAddDirs');
  ShowMessage(FloatToStr(TempDbl));
  AnIniFil.Kill;}

  {AnIniFil := TAnIniFile.Init;
  AnIniFil.Load(Path+'TestFls\settings.ini');
  //AnIniFil.MakNewFile;
  AnIniFil.WriteString('Cheburs1','Zuba1','ZUBZUB-237');
  AnIniFil.WriteString('Settings','ResultDir','test1');
  AnIniFil.WriteString('testing','tosting2','test2');
  AnIniFil.Save(Path+'TestFls\settons.ini');
  AnIniFil.WriteString('testing','tosting3','test3');
  AnIniFil.WriteString('testing2','tosting4','test4');
  AnIniFil.Save(Path+'TestFls\settons.ini');
  AnIniFil.Kill;}

  {AnIniFil := TAnIniFile.Init;
  AnIniFil.Load(Path+'TestFls\settons.ini');
  AnIniFil.MakNewFile;
  AnIniFil.WriteString('Cheburs1','Zuba1','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs1','Zuba2','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs1','Zuba3','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs2','Zuba4','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs2','Zuba5','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs2','Zuba6','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs3','Zuba7','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs3','Zuba8','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs3','Zuba9','ZUBZUB-237');
  AnIniFil.WriteString('Cheburs4','Zuba10','ZUBZUB-237');
  AnIniFil.Save(Path+'TestFls\settons.ini');
  AnIniFil.Kill;}

  {If DirectoryExists('tester.txt') = true then begin
    ShowMessage(' ,   ...');
  end;}

  {TestBool := StrSatisfy('sagrer@yandex.ru','*@*.*');
  If TestBool  then begin
    showmessage('ok');
  end;}

  //TextEdForms[1].SaveBut.Enabled := false;

end;

procedure TMainForm.IshSBClick(Sender: TObject);
begin
  IshF.IshMenalsa := false;
  IshF.ShowModal;
  If IshF.IshMenalsa = true then CloseLishneeBase; //  
                                          //  .
end;

procedure TMainForm.Bas_Mult_Prints_Razd1MenuClick(Sender: TObject);
begin
  if Bas_Mult_Prints_Razd1Menu.Checked = false then begin
    Bas_Mult_Prints_Razd1Menu.Checked := true;
    PrintsDbR1F := TPrintsDbR1F.Create(Application);
    PrintsDbR1F.show;
  end
  else begin
    PrintsDbR1F.Close;
    Bas_Mult_Prints_Razd1Menu.Checked := false;
  end;
end;

procedure TMainForm.Bas_Mult_Prints_Razd2MenuClick(Sender: TObject);
begin
  if Bas_Mult_Prints_Razd2Menu.Checked = false then begin
    Bas_Mult_Prints_Razd2Menu.Checked := true;
    PrintsDbR2F := TPrintsDbR2F.Create(Application);
    PrintsDbR2F.show;
  end
  else begin
    PrintsDbR2F.Close;
    Bas_Mult_Prints_Razd2Menu.Checked := false;
  end;
end;

procedure TMainForm.Bas_Mult_Prints_Razd3MenuClick(Sender: TObject);
begin
  if Bas_Mult_Prints_Razd3Menu.Checked = false then begin
    Bas_Mult_Prints_Razd3Menu.Checked := true;
    PrintsDbR3F := TPrintsDbR3F.Create(Application);
    PrintsDbR3F.show;
  end
  else begin
    PrintsDbR3F.Close;
    Bas_Mult_Prints_Razd3Menu.Checked := false;
  end;
end;

procedure TMainForm.LmpLeversMenuClick(Sender: TObject);
begin
  if LmpLeversMenu.Checked = false then begin
    LmpLeversMenu.Checked := true;
    LmpLeversF := TLmpLeversF.Create(Application);
    LmpLeversF.show;
  end
  else begin
    LmpLeversF.Close;
    LmpLeversMenu.Checked := false;
  end;
end;

procedure TMainForm.LeversMenuClick(Sender: TObject);
begin
  if LeversMenu.Checked = false then begin
    LeversMenu.Checked := true;
    LeversF := TLeversF.Create(Application);
    LeversF.show;
  end
  else begin
    LeversF.Close;
    LeversMenu.Checked := false;
  end;
end;

procedure TMainForm.PrintsMenu1Click(Sender: TObject);
begin
  if PrintsMenu1.Checked = false then begin
    PrintsMenu1.Checked := true;
    SinglPrintsDbR1F := TSinglPrintsDbR1F.Create(Application);
    SinglPrintsDbR1F.show;
  end
  else begin
    SinglPrintsDbR1F.Close;
    PrintsMenu1.Checked := false;
  end;
end;

procedure TMainForm.PrintsMenu2Click(Sender: TObject);
begin
  if PrintsMenu2.Checked = false then begin
    PrintsMenu2.Checked := true;
    SinglPrintsDbR2F := TSinglPrintsDbR2F.Create(Application);
    SinglPrintsDbR2F.show;
  end
  else begin
    SinglPrintsDbR2F.Close;
    PrintsMenu2.Checked := false;
  end;
end;

procedure TMainForm.PrintsMenu3Click(Sender: TObject);
begin
  if PrintsMenu3.Checked = false then begin
    PrintsMenu3.Checked := true;
    SinglPrintsDbR3F := TSinglPrintsDbR3F.Create(Application);
    SinglPrintsDbR3F.show;
  end
  else begin
    SinglPrintsDbR3F.Close;
    PrintsMenu3.Checked := false;
  end;
end;

procedure TMainForm.ItemsMenu1Click(Sender: TObject);
begin
  if ItemsMenu1.Checked = false then begin
    ItemsMenu1.Checked := true;
    SinglItemsIdbR1F := TSinglItemsIdbR1F.Create(Application);
    SinglItemsIdbR1F.show;
  end
  else begin
    SinglItemsIdbR1F.Close;
    ItemsMenu1.Checked := false;
  end;
end;

procedure TMainForm.LmpItemsMenu1Click(Sender: TObject);
begin
  if LmpItemsMenu1.Checked = false then begin
    LmpItemsMenu1.Checked := true;
    ItemsIdbR1F := TItemsIdbR1F.Create(Application);
    ItemsIdbR1F.show;
  end
  else begin
    ItemsIdbR1F.Close;
    LmpItemsMenu1.Checked := false;
  end;
end;

procedure TMainForm.ItemsMenu2Click(Sender: TObject);
begin
  if ItemsMenu2.Checked = false then begin
    ItemsMenu2.Checked := true;
    SinglItemsIdbR2F := TSinglItemsIdbR2F.Create(Application);
    SinglItemsIdbR2F.show;
  end
  else begin
    SinglItemsIdbR2F.Close;
    ItemsMenu2.Checked := false;
  end;
end;

procedure TMainForm.LmpItemsMenu2Click(Sender: TObject);
begin
  if LmpItemsMenu2.Checked = false then begin
    LmpItemsMenu2.Checked := true;
    ItemsIdbR2F := TItemsIdbR2F.Create(Application);
    ItemsIdbR2F.show;
  end
  else begin
    ItemsIdbR2F.Close;
    LmpItemsMenu2.Checked := false;
  end;
end;

procedure TMainForm.ItemsMenu3Click(Sender: TObject);
begin
  if ItemsMenu3.Checked = false then begin
    ItemsMenu3.Checked := true;
    SinglItemsIdbR3F := TSinglItemsIdbR3F.Create(Application);
    SinglItemsIdbR3F.show;
  end
  else begin
    SinglItemsIdbR3F.Close;
    ItemsMenu3.Checked := false;
  end;
end;

procedure TMainForm.LmpItemsMenu3Click(Sender: TObject);
begin
  if LmpItemsMenu3.Checked = false then begin
    LmpItemsMenu3.Checked := true;
    ItemsIdbR3F := TItemsIdbR3F.Create(Application);
    ItemsIdbR3F.show;
  end
  else begin
    ItemsIdbR3F.Close;
    LmpItemsMenu3.Checked := false;
  end;
end;

procedure TMainForm.ItemsMenu4Click(Sender: TObject);
begin
  if ItemsMenu4.Checked = false then begin
    ItemsMenu4.Checked := true;
    SinglItemsIdbR4F := TSinglItemsIdbR4F.Create(Application);
    SinglItemsIdbR4F.show;
  end
  else begin
    SinglItemsIdbR4F.Close;
    ItemsMenu4.Checked := false;
  end;
end;

procedure TMainForm.LmpItemsMenu4Click(Sender: TObject);
begin
  if LmpItemsMenu4.Checked = false then begin
    LmpItemsMenu4.Checked := true;
    ItemsIdbR4F := TItemsIdbR4F.Create(Application);
    ItemsIdbR4F.show;
  end
  else begin
    ItemsIdbR4F.Close;
    LmpItemsMenu4.Checked := false;
  end;
end;

procedure TMainForm.ItemsMenu5Click(Sender: TObject);
begin
  if ItemsMenu5.Checked = false then begin
    ItemsMenu5.Checked := true;
    SinglItemsIdbR5F := TSinglItemsIdbR5F.Create(Application);
    SinglItemsIdbR5F.show;
  end
  else begin
    SinglItemsIdbR5F.Close;
    ItemsMenu5.Checked := false;
  end;
end;

procedure TMainForm.LmpItemsMenu5Click(Sender: TObject);
begin
  if LmpItemsMenu5.Checked = false then begin
    LmpItemsMenu5.Checked := true;
    ItemsIdbR5F := TItemsIdbR5F.Create(Application);
    ItemsIdbR5F.show;
  end
  else begin
    ItemsIdbR5F.Close;
    LmpItemsMenu5.Checked := false;
  end;
end;

procedure TMainForm.ItemsMenu6Click(Sender: TObject);
begin
  if ItemsMenu6.Checked = false then begin
    ItemsMenu6.Checked := true;
    SinglItemsIdbR6F := TSinglItemsIdbR6F.Create(Application);
    SinglItemsIdbR6F.show;
  end
  else begin
    SinglItemsIdbR6F.Close;
    ItemsMenu6.Checked := false;
  end;
end;

procedure TMainForm.LmpItemsMenu6Click(Sender: TObject);
begin
  if LmpItemsMenu6.Checked = false then begin
    LmpItemsMenu6.Checked := true;
    ItemsIdbR6F := TItemsIdbR6F.Create(Application);
    ItemsIdbR6F.show;
  end
  else begin
    ItemsIdbR6F.Close;
    LmpItemsMenu6.Checked := false;
  end;
end;

procedure TMainForm.PerksMenu1Click(Sender: TObject);
begin
  if PerksMenu1.Checked = false then begin
    PerksMenu1.Checked := true;
    SinglPerksPdbR1F := TSinglPerksPdbR1F.Create(Application);
    SinglPerksPdbR1F.show;
  end
  else begin
    SinglPerksPdbR1F.Close;
    PerksMenu1.Checked := false;
  end;
end;

procedure TMainForm.LmpPerksMenu1Click(Sender: TObject);
begin
  if LmpPerksMenu1.Checked = false then begin
    LmpPerksMenu1.Checked := true;
    PerksPdbR1F := TPerksPdbR1F.Create(Application);
    PerksPdbR1F.show;
  end
  else begin
    PerksPdbR1F.Close;
    LmpPerksMenu1.Checked := false;
  end;
end;

procedure TMainForm.PerksMenu2Click(Sender: TObject);
begin
  if PerksMenu2.Checked = false then begin
    PerksMenu2.Checked := true;
    SinglPerksPdbR2F := TSinglPerksPdbR2F.Create(Application);
    SinglPerksPdbR2F.show;
  end
  else begin
    SinglPerksPdbR2F.Close;
    PerksMenu2.Checked := false;
  end;
end;

procedure TMainForm.LmpPerksMenu2Click(Sender: TObject);
begin
  if LmpPerksMenu2.Checked = false then begin
    LmpPerksMenu2.Checked := true;
    PerksPdbR2F := TPerksPdbR2F.Create(Application);
    PerksPdbR2F.show;
  end
  else begin
    PerksPdbR2F.Close;
    LmpPerksMenu2.Checked := false;
  end;
end;

procedure TMainForm.QuestsMenu1Click(Sender: TObject);
begin
  if QuestsMenu1.Checked = false then begin
    QuestsMenu1.Checked := true;
    SinglQuestsQdbR1F := TSinglQuestsQdbR1F.Create(Application);
    SinglQuestsQdbR1F.show;
  end
  else begin
    SinglQuestsQdbR1F.Close;
    QuestsMenu1.Checked := false;
  end;
end;

procedure TMainForm.QuestsMenu2Click(Sender: TObject);
begin
  if QuestsMenu2.Checked = false then begin
    QuestsMenu2.Checked := true;
    SinglQuestsQdbR2F := TSinglQuestsQdbR2F.Create(Application);
    SinglQuestsQdbR2F.show;
  end
  else begin
    SinglQuestsQdbR2F.Close;
    QuestsMenu2.Checked := false;
  end;
end;

procedure TMainForm.LmpUnitsMenu1Click(Sender: TObject);
begin
  if LmpUnitsMenu1.Checked = false then begin
    LmpUnitsMenu1.Checked := true;
    UnitsUdbR1F := TUnitsUdbR1F.Create(Application);
    UnitsUdbR1F.show;
  end
  else begin
    UnitsUdbR1F.Close;
    LmpUnitsMenu1.Checked := false;
  end;
end;

procedure TMainForm.UnitsMenu1Click(Sender: TObject);
begin
  if UnitsMenu1.Checked = false then begin
    UnitsMenu1.Checked := true;
    SinglUnitsUdbR1F := TSinglUnitsUdbR1F.Create(Application);
    SinglUnitsUdbR1F.show;
  end
  else begin
    SinglUnitsUdbR1F.Close;
    UnitsMenu1.Checked := false;
  end;
end;

procedure TMainForm.UnitsMenu2Click(Sender: TObject);
begin
  if UnitsMenu2.Checked = false then begin
    UnitsMenu2.Checked := true;
    SinglUnitsUdbR2F := TSinglUnitsUdbR2F.Create(Application);
    SinglUnitsUdbR2F.show;
  end
  else begin
    SinglUnitsUdbR2F.Close;
    UnitsMenu2.Checked := false;
  end;
end;

procedure TMainForm.LmpUnitsMenu2Click(Sender: TObject);
begin
  if LmpUnitsMenu2.Checked = false then begin
    LmpUnitsMenu2.Checked := true;
    UnitsUdbR2F := TUnitsUdbR2F.Create(Application);
    UnitsUdbR2F.show;
  end
  else begin
    UnitsUdbR2F.Close;
    LmpUnitsMenu2.Checked := false;
  end;
end;

procedure TMainForm.UnitsMenu3Click(Sender: TObject);
begin
  if UnitsMenu3.Checked = false then begin
    UnitsMenu3.Checked := true;
    SinglUnitsUdbR3F := TSinglUnitsUdbR3F.Create(Application);
    SinglUnitsUdbR3F.show;
  end
  else begin
    SinglUnitsUdbR3F.Close;
    UnitsMenu3.Checked := false;
  end;
end;

procedure TMainForm.LmpUnitsMenu3Click(Sender: TObject);
begin
  if LmpUnitsMenu3.Checked = false then begin
    LmpUnitsMenu3.Checked := true;
    UnitsUdbR3F := TUnitsUdbR3F.Create(Application);
    UnitsUdbR3F.show;
  end
  else begin
    UnitsUdbR3F.Close;
    LmpUnitsMenu3.Checked := false;
  end;
end;

procedure TMainForm.UnitsMenu4Click(Sender: TObject);
begin
  if UnitsMenu4.Checked = false then begin
    UnitsMenu4.Checked := true;
    SinglUnitsUdbR4F := TSinglUnitsUdbR4F.Create(Application);
    SinglUnitsUdbR4F.show;
  end
  else begin
    SinglUnitsUdbR4F.Close;
    UnitsMenu4.Checked := false;
  end;
end;

procedure TMainForm.LmpUnitsMenu4Click(Sender: TObject);
begin
  if LmpUnitsMenu4.Checked = false then begin
    LmpUnitsMenu4.Checked := true;
    UnitsUdbR4F := TUnitsUdbR4F.Create(Application);
    UnitsUdbR4F.show;
  end
  else begin
    UnitsUdbR4F.Close;
    LmpUnitsMenu4.Checked := false;
  end;
end;

procedure TMainForm.SpellsMenu1Click(Sender: TObject);
begin
  if SpellsMenu1.Checked = false then begin
    SpellsMenu1.Checked := true;
    SinglSpellsSdbR1F := TSinglSpellsSdbR1F.Create(Application);
    SinglSpellsSdbR1F.show;
  end
  else begin
    SinglSpellsSdbR1F.Close;
    SpellsMenu1.Checked := false;
  end;
end;

procedure TMainForm.LmpSpellsMenu1Click(Sender: TObject);
begin
  if LmpSpellsMenu1.Checked = false then begin
    LmpSpellsMenu1.Checked := true;
    SpellsSdbR1F := TSpellsSdbR1F.Create(Application);
    SpellsSdbR1F.show;
  end
  else begin
    SpellsSdbR1F.Close;
    LmpSpellsMenu1.Checked := false;
  end;
end;

procedure TMainForm.SpellsMenu2Click(Sender: TObject);
begin
  if SpellsMenu2.Checked = false then begin
    SpellsMenu2.Checked := true;
    SinglSpellsSdbR2F := TSinglSpellsSdbR2F.Create(Application);
    SinglSpellsSdbR2F.show;
  end
  else begin
    SinglSpellsSdbR2F.Close;
    SpellsMenu2.Checked := false;
  end;
end;

procedure TMainForm.LmpSpellsMenu2Click(Sender: TObject);
begin
  if LmpSpellsMenu2.Checked = false then begin
    LmpSpellsMenu2.Checked := true;
    SpellsSdbR2F := TSpellsSdbR2F.Create(Application);
    SpellsSdbR2F.show;
  end
  else begin
    SpellsSdbR2F.Close;
    LmpSpellsMenu2.Checked := false;
  end;
end;

procedure TMainForm.SpellsMenu3Click(Sender: TObject);
begin
  if SpellsMenu3.Checked = false then begin
    SpellsMenu3.Checked := true;
    SinglSpellsSdbR3F := TSinglSpellsSdbR3F.Create(Application);
    SinglSpellsSdbR3F.show;
  end
  else begin
    SinglSpellsSdbR3F.Close;
    SpellsMenu3.Checked := false;
  end;
end;

procedure TMainForm.LmpSpellsMenu3Click(Sender: TObject);
begin
  if LmpSpellsMenu3.Checked = false then begin
    LmpSpellsMenu3.Checked := true;
    SpellsSdbR3F := TSpellsSdbR3F.Create(Application);
    SpellsSdbR3F.show;
  end
  else begin
    SpellsSdbR3F.Close;
    LmpSpellsMenu3.Checked := false;
  end;
end;

procedure TMainForm.SpellsMenu4Click(Sender: TObject);
begin
  if SpellsMenu4.Checked = false then begin
    SpellsMenu4.Checked := true;
    SinglSpellsSdbR4F := TSinglSpellsSdbR4F.Create(Application);
    SinglSpellsSdbR4F.show;
  end
  else begin
    SinglSpellsSdbR4F.Close;
    SpellsMenu4.Checked := false;
  end;
end;  

procedure TMainForm.LmpSpellsMenu4Click(Sender: TObject);
begin
  if LmpSpellsMenu4.Checked = false then begin
    LmpSpellsMenu4.Checked := true;
    SpellsSdbR4F := TSpellsSdbR4F.Create(Application);
    SpellsSdbR4F.show;
  end
  else begin
    SpellsSdbR4F.Close;
    LmpSpellsMenu4.Checked := false;
  end;
end;

procedure TMainForm.SpellsMenu5Click(Sender: TObject);
begin
  if SpellsMenu5.Checked = false then begin
    SpellsMenu5.Checked := true;
    SinglSpellsSdbR5F := TSinglSpellsSdbR5F.Create(Application);
    SinglSpellsSdbR5F.show;
  end
  else begin
    SinglSpellsSdbR5F.Close;
    SpellsMenu5.Checked := false;
  end;
end;

procedure TMainForm.LmpSpellsMenu5Click(Sender: TObject);
begin
  if LmpSpellsMenu5.Checked = false then begin
    LmpSpellsMenu5.Checked := true;
    SpellsSdbR5F := TSpellsSdbR5F.Create(Application);
    SpellsSdbR5F.show;
  end
  else begin
    SpellsSdbR5F.Close;
    LmpSpellsMenu5.Checked := false;
  end;
end;

procedure TMainForm.AcksMenu1Click(Sender: TObject);
begin
  if AcksMenu1.Checked = false then begin
    AcksMenu1.Checked := true;
    SinglAcksDbR1F := TSinglAcksDbR1F.Create(Application);
    SinglAcksDbR1F.show;
  end
  else begin
    SinglAcksDbR1F.Close;
    AcksMenu1.Checked := false;
  end;
end;

procedure TMainForm.AcksMenu2Click(Sender: TObject);
begin
  if AcksMenu2.Checked = false then begin
    AcksMenu2.Checked := true;
    SinglAcksDbR2F := TSinglAcksDbR2F.Create(Application);
    SinglAcksDbR2F.show;
  end
  else begin
    SinglAcksDbR2F.Close;
    AcksMenu2.Checked := false;
  end;
end;

procedure TMainForm.AcksMenu3Click(Sender: TObject);
begin
  if AcksMenu3.Checked = false then begin
    AcksMenu3.Checked := true;
    SinglAcksDbR3F := TSinglAcksDbR3F.Create(Application);
    SinglAcksDbR3F.show;
  end
  else begin
    SinglAcksDbR3F.Close;
    AcksMenu3.Checked := false;
  end;
end;

procedure TMainForm.ResOptMenuClick(Sender: TObject);
begin
  //     *.res .
  ResPathsF := TResPathsF.Create(Application);    //
  ResPathsF.ShowModal;     // 
  ResPathsF.Free;          //   .
end;

procedure TMainForm.TextEditMenuClick(Sender: TObject);
var
  I : integer;
  Finded : boolean;

begin
  Finded := false;
  if TextEdF_Quantity <> 0 then begin
    //    -  -    
    // -         .
    I := -1;
    repeat
      I := I+1;
      if TextEdForms[I] = nil then begin
        //    .
        Finded := true;
        CurrNumInArr := I;
        I := TextEdF_Quantity-1;  //    .
        //   .
        TextEdForms[CurrNumInArr] := TTextEdF.Create(Application);
      end;
    until I = TextEdF_Quantity-1;
  end;

  if Finded = false then begin
    //   -       .
    TextEdF_Quantity := TextEdF_Quantity+1;
    SetLength(TextEdForms,TextEdF_Quantity);
    CurrNumInArr := TextEdF_Quantity-1;
    TextEdForms[TextEdF_Quantity-1] := TTextEdF.Create(Application);
  end;  
end;

procedure TMainForm.TextEdSBClick(Sender: TObject);
begin
  TextEditMenuClick(Application);
end;

procedure TMainForm.CascadeWindMenuClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.TileWindMenuClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.ArrangeIconsWindMenuClick(Sender: TObject);
begin
  ArrangeIcons;
end;

end.











